tree grammar decl;

options {
    tokenVocab=pipe;
    output=AST;
    ASTLabelType=CommonTree;
}


@header {
import org.stringtemplate.v4.*;
import java.util.HashMap;
import java.io.FileWriter;
}

starting
    : game+
    ;

//^(CLASS SYMBOL_NAME (node)*)
game
    : 
        {
            STGroup header = new STGroupFile("st/header.stg");
            ST class_delc = header.getInstanceOf("class_delc");
        }
        ^(CLASS SYMBOL_NAME
            {
                class_delc.add("CLASS_NAME", $SYMBOL_NAME.text);
                class_delc.add("CLASS_UPPER", $SYMBOL_NAME.text.toUpperCase());
            }
            (node 
                {
                    HashMap mf = new HashMap();
                    mf.put("class_name", $SYMBOL_NAME.text);
                    mf.put("function_name", $node.node_name);
                    mf.put("para_name", $node.para_name);
                    class_delc.add("member_function_list", mf);
                }
            )*)
        {
            String result = class_delc.render();
            System.out.println(result);

            try{
                FileWriter fw = new FileWriter("method_chaining_demo/"+$SYMBOL_NAME.text+".h");
                fw.write(result);
                fw.flush();
            }
            catch (java.io.IOException e)
                {
                    System.err.println(e); 
                }
        }
    ;

//^(NODE SYMBOL_NAME (PARA INT)?)
node
returns [String node_name, String para_name]
@init {
    $node_name = "";
    $para_name = "";
}
    : 
^(NODE SYMBOL_NAME (PARA INT
                {
                    $para_name = "int par";
                }
            )?)
        {
            $node_name=$SYMBOL_NAME.text;
        }
    ;
