tree grammar def;

options {
    tokenVocab=pipe;
    output=AST;
    ASTLabelType=CommonTree;
}


@header {
import org.stringtemplate.v4.*;
import java.util.HashMap;
import java.io.FileWriter;
}

starting
    : game+
    ;

//^(CLASS SYMBOL_NAME (node)*)
game
    : 
        {
            STGroup cpp = new STGroupFile("st/cpp.stg");
            ST class_def = cpp.getInstanceOf("class_def");
        }
        ^(CLASS SYMBOL_NAME
            {
                class_def.add("CLASS_NAME", $SYMBOL_NAME.text);
            }
            (node 
                { 
                    class function
                    {
                        public String class_name;
                        public String node_name;
                        public String para_name;
                        public String getClass_name() {return class_name;}
                        public String getnode_name() {return node_name;}
                        public String getPara_name() {return para_name;}
                    }
                    
                    function f = new function();
                    f.class_name = $SYMBOL_NAME.text;
                    f.node_name = $node.node_name;
                    if($node.is_with_para == true)
                        {
                            f.para_name = $node.para_name;
                            class_def.add("member_function_list_with_para", f);
                        }
                    else
                        {
                            class_def.add("member_function_list", f);
                        }
                    

                    // HashMap mf = new HashMap();
                    // mf.put("CLASS_NAME", $SYMBOL_NAME.text);
                    // mf.put("node_name", $node.node_name);
                    // if($node.is_with_para == true)
                    //     {
                    //         mf.put("para_name", $node.para_name);
                    //         class_def.add("member_function_list_with_para", new HashMap(mf));
                    //     }
                    // else
                    //     {
                    //         class_def.add("member_function_list", new HashMap(mf));
                    //     }
                      // System.out.println("here..."+$SYMBOL_NAME.text+" "+$node.node_name+" "+$node.para_name+" "+$node.is_with_para);
                }
            )*)
        {
            String result = class_def.render();
            System.out.println(result);

            try{
                FileWriter fw = new FileWriter("method_chaining_demo/"+$SYMBOL_NAME.text+".cpp");
                fw.write(result);
                fw.flush();
            }
            catch (java.io.IOException e)
                {
                    System.err.println(e); 
                }
        }
    ;

//^(NODE SYMBOL_NAME (PARA INT)?)
node
returns [String node_name, String para_name, boolean is_with_para]
@init {
    $node_name = "";
    $para_name="";
    $is_with_para = false;
}
    : 
^(NODE SYMBOL_NAME (PARA INT
                {
                    $is_with_para = true;
                    $para_name="par";
                }
            )?)
        {
            $node_name=$SYMBOL_NAME.text;
        }
    ;
